#include "pch.h"
#include "Student.h"

Student::Student(int mid, intptr mpassed, int mnumber):id { mid }, passed{ mpassed }, number{ mnumber }
{
}

Student::Student(int mid) : Student(mid, nullptr, 0)
{
}

Student::Student(): Student(0,nullptr,0)
{
}

Student::Student(const Student & std):id{std.id},number{std.number}
{
	passed = new int[number];
	for (int i = 0; i < number; ++i)
		passed[i] = std.passed[i];
}

Student::~Student()
{
	delete[]passed;
}

void Student::set_id(int mid)
{
	id = mid;
}

bool Student::set_lesson(int lessid)
{
	if (search_lesson(lessid))
		return false;
	
	intptr newpass = new int[number + 1];
	for (int i = 0; i < number; ++i)
		newpass[i] = passed[i];
	delete[]passed;
	newpass[number] = lessid;
	passed = newpass;
	++number;

	return true;
}

int Student::get_number()
{
	return number;
}

intptr Student::get_passed()
{
	return passed;
}

Student & Student::operator=(const Student & rhs)
{
	id = rhs.id;
	number = rhs.number;

	if (this->passed != rhs.passed) {
		delete []this->passed;
		this->passed = new int[number];
		for (int i = 0; i < number; ++i)
			this->passed[i] = rhs.passed[i];
	}
	return *this;
}

bool Student::search_lesson(int lessid)
{
	for (int i = 0; i < number; ++i)
		if (lessid == passed[i])
			return true;
	return false;
}

std::ostream & operator<<(std::ostream &os, const Student&std)
{
	os << "Student: "<<std.id<<" - Passed lessons: ";
	for (int i = 0; i < std.number; ++i) {
		os << std.passed[i] << " ";
	}
	os << std::endl;
	return os;
}
