#include "pch.h"
#include "Matrix.h"
#include<iostream>


Matrix::Matrix(): size{0},data{nullptr}
{
}

Matrix::Matrix(int msize): Matrix(msize,0)
{
}

Matrix::Matrix(int msize, int value) : size{msize}
{
	data = new int[size*size];
	for (int i = 0; i < size*size; ++i)
		data[i] = value;
}


Matrix::~Matrix()
{
	delete[]data;
}

Matrix & Matrix::operator=(const Matrix & mat)
{
	if (size != mat.size) {
		std::cout << "Incompatible matrices size\n";
		Matrix *tmp = new Matrix;
		return (*tmp);
	}
	
	for (int i = 0; i < size*size; ++i)
		data[i] = mat.data[i];
	return (*this);
}

std::istream & operator>>(std::istream & in, Matrix & item)
{
	if (item.size == 0) {
		std::cout << "Matrix has size zero!!!!\n";
		return in;
	}
	std::cout << "Reading square matrix with size " << item.size << ": ";
	
	for (int i = 0; i < item.size; ++i)
		for (int j = 0; j < item.size; ++j)
			in >> item.data[i*item.size+j];
	return in;
}

std::ostream & operator<<(std::ostream & out, const Matrix & item)
{
	if (item.size == 0) {
		std::cout << "Matrix has size zero!!!!\n";
		return out;
	}
	std::cout << "Printing suare matrix with size " << item.size << std::endl;

	for (int i = 0; i < item.size; ++i) {
		for (int j = 0; j < item.size; ++j)
			out << item.data[i*item.size + j] << " ";
		std::cout << std::endl;
	}
	return out;
}

Matrix & operator+(const Matrix & lhs, const Matrix & rhs)
{
	if (lhs.size != rhs.size) {
		std::cout << "Incompatible matrices size\n";
		Matrix *tmp = new Matrix;
		return (*tmp);
	}
	Matrix *tmp = new Matrix{ rhs.size };
	for (int i = 0; i < rhs.size*rhs.size; ++i)
		tmp->data[i] = lhs.data[i] + rhs.data[i];
	return (*tmp);

}
